﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

public class GameParameter
{
	protected float currentValue;
	protected readonly float minValue;
	protected readonly float maxValue;

	public virtual float value
	{
		get { return currentValue; }
		set { currentValue = Mathf.Clamp(value, minValue, maxValue); }
	}

	public float rate
	{
		set
		{
			if (value < 0 || value > 1)
			{
				Debug.LogError("Rate valu must be only between 0 and 1");
				return;
			}

			currentValue = maxValue * value;
		}
	}

	public GameParameter(float min, float max, float initValue)
	{
		minValue = min;
		maxValue = max;
		value = initValue;
	}

}