﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

public class Teampoint : MonoBehaviour
{
    [SerializeField] public CharacterComponent teamGD;

    [SerializeField] private float _creativity;
	[SerializeField] private Sprite imgtemp;
	[SerializeField] private IdeaHolderComponent _ideaHolder;
	[SerializeField] private List<Chair> _chairs;

	public float gameProgress { get; private set; }

	private float _timer = 0f;
	private float _pauseTime = 8f;
	private bool _hiding = false;

	private float _gameSpeed = 1f;

	void Start()
	{
		//_creativity = 1;
      //  if (teamGD)
		    //teamGD.SetTeam(this);
	}

	void Update()
	{
		if (_chairs.Count(ch => ch.isWorking) > 0)
			gameProgress += Time.deltaTime * _gameSpeed;
		//Debug.Log(_hiding);
		if (_hiding)
			return;

		_timer -= Time.deltaTime;
		if (_timer <= 0)
		{
			if (_ideaHolder.ideasCount < 2)
				_ideaHolder.CreateIdea(_hiding);

			_timer = _pauseTime / _creativity;
		}

	}

	void FixedUpdate() { 
		//Debug.Log(_ideaHolder.GetActiveIdeasAmount());

		_gameSpeed = 0.5f + _ideaHolder.GetActiveIdeasAmount() * 0.5f;

        //Debug.Log(_chairs[0].isWorking);
        if ((Physics2D
            .OverlapCircleAll(transform.position,
                GetComponent<CircleCollider2D>().radius).Where(o => o.tag == "GD").Any(g => g.gameObject.GetComponent<PlayerComponent>()) && teamGD.GetComponent<PlayerComponent>() == null)
				|| _chairs.Count(ch => ch.isWorking) < 1)
		{
			if (!_hiding)
			{
				_ideaHolder.hideAll = true;
				_hiding = true;
			}
		}
		else
		{
			if (_hiding)
			{
				_ideaHolder.hideAll = false;
				_hiding = false;
				_timer = _pauseTime / _creativity;
			}
		}

	}

	public Idea GetRandomIdea()
	{
		return _ideaHolder.GetRandomIdea();
	}

	public Chair GetFreeChair()
	{
		//Debug.Log(_chairs.Count);
		var freeChairs = _chairs.Where(chair => chair.isFree).ToList();
		//Debug.Log(freeChairs.Count);
		if (freeChairs.Count == 0)
			return null;

		var ch = freeChairs[UnityEngine.Random.Range(0, freeChairs.Count)];
		ch.isFree = false;
		
		return ch;
	}

}

