﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;
using UnityEngine.UI;


public class WaveSetting : MonoBehaviour
{
	[SerializeField] private GameObject startx;
	[SerializeField] public GameObject endx;

	[SerializeField] private GameObject redPrefab;
	[SerializeField] private GameObject greenPrefab;

	[SerializeField] private Text timerText;

	[SerializeField] private AudioSource wrongAns;
	[SerializeField] private AudioSource rightAns;

	public event Action onSuccess;
	public event Action onStop;

	private bool started;

	public float yCoef;
	public float xCoef;

	public float yCoefStatic;
	public float xCoefStatic;

	void Start()
	{
		//started = false;
		//Init();
	}

	private bool down, up, left, right;

	private float _createTimer = 0f;
	private float _timer;

	public void Init(Action success, Action stop)
	{
		onSuccess += success;
		onStop += stop;

		//gameObject.SetActive(true);
		xCoefStatic = UnityEngine.Random.Range(0.6f, 2.1f);
		yCoefStatic = UnityEngine.Random.Range(30f, 48f);
		xCoef = 1.5f;
		yCoef = 10f;
		started = true;
		timerText.gameObject.SetActive(true);
		_timer = 3.5f;
		//Debug.Log("init " + started);
	}

	public void Stop()
	{
		if (onStop != null)
			onStop();

		started = false;
		onSuccess = null;
		down = false;
		up = false;
		left = false;
		right = false;
		timerText.gameObject.SetActive(false);
		gameObject.SetActive(false);
	}

	void Update()
	{
		//Debug.Log(started);
		if (!started)
			return;

		xCoef += Time.deltaTime * (Convert.ToInt16(right) - Convert.ToInt16(left)) * 0.71f;
		yCoef += Time.deltaTime * (Convert.ToInt16(up) - Convert.ToInt16(down)) * 14;
		_timer -= Time.deltaTime;

		if (_timer <= 0)
		{
			wrongAns.Play();
			Stop();
		}

		if (Input.GetKeyDown(KeyCode.DownArrow))
			down = true;
		if (Input.GetKeyDown(KeyCode.LeftArrow))
			left = true;
		if (Input.GetKeyDown(KeyCode.UpArrow))
			up = true;
		if (Input.GetKeyDown(KeyCode.RightArrow))
			right = true;

		if (Input.GetKeyUp(KeyCode.DownArrow))
			down = false;
		if (Input.GetKeyUp(KeyCode.LeftArrow))
			left = false;
		if (Input.GetKeyUp(KeyCode.UpArrow))
			up = false;
		if (Input.GetKeyUp(KeyCode.RightArrow))
			right = false;

		if (Mathf.Abs(yCoef - yCoefStatic) < 0.9f && Mathf.Abs(xCoef - xCoefStatic) < 0.07f)
		{
			Success();
		}

		timerText.text = "0" + ((int) _timer + 1).ToString();

		_createTimer -= Time.deltaTime;
		if (_createTimer < 0)
		{
			var green = Instantiate(greenPrefab, transform) as GameObject;
			green.transform.localScale = new Vector3(1,1,1);
			green.GetComponent<WavePoint>().parent = this;
			green.transform.localPosition = startx.transform.localPosition;

			var red = Instantiate(redPrefab, transform) as GameObject;
			red.transform.localScale = new Vector3(1, 1, 1);
			red.GetComponent<WavePoint>().parent = this;
			red.transform.localPosition = startx.transform.localPosition;
			_createTimer = 0.08f;
		}
	}

	void Success()
	{
		rightAns.Play();
		if (onSuccess != null)
			onSuccess();

		Stop();
		
	}

}

