﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;


public class MovementComponent : MonoBehaviour
{
    [SerializeField] private float _maxSpeed;

	public GameParameter speed { get; private set; }
	public Vector3 direction { get; private set; }

	public static MovementComponent Create(GameObject go, float maxSpeed)
	{
		var mc = go.AddComponent<MovementComponent>();
        mc.speed = new GameParameter(0, maxSpeed, 0);
        return mc;
	}

    void Awake()
    {
        
        speed = new GameParameter(0, _maxSpeed, 0);
        direction = new Vector3();
    }

	protected void Update()
	{
		transform.position += direction * speed.value * Time.deltaTime;
	}

	public void SetMovementSpeedRate(float rate)
	{
        
		speed.rate = rate;
	}

	public void SetMovementDirection(Vector3 dir)
	{
		direction = dir;
	}

}